;
; basic.asm - basic extensions
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;**************************************************
;Basic extensions
;
;Listing does not have problems.
;Tokenizer may have problems with irq $8000-$9fff or turned off basic...
;Token executor may have problems with irq $8000-$9fff or turned off basic...
;**************************************************
; duplicated day names!
;---------------------------
;LIST modification (cfg_open)
;
OP_mylist	.proc
		cmp #$f0		;Our codes from $f0
		bcc back
		cmp #$ff		;PI
		beq back		;C=0
		bit $0f			;" mode
		bmi back
listbank0	.global
		sbc #$ee
		tax
		sty $49
		ldy #$ff
next		dex
		beq printlp
loop		iny
		lda newcommands,y
		bpl loop
		gmi next

printlp		iny
		lda newcommands,y
		bmi end
		jsr newchrout_t		; chrout (cfg_16)
		gcc printlp

end		and #$7f
		ldy $49
back		sta $49
		#psr $a71a
		lda $49
		jmp switch_norm
		.pend
;---------------------------
;New BASIC keywords
;
newcommands	.proc
		.text "L",128+"L"	;$f0
		.text "DI",128+"R"	;$f1
		.text "C",128+"D"	;$f2
		.text "R",128+"M"	;$f3
		.text "MKDI",128+"R"	;$f4
		.text "HDINI",128+"T"	;$f5
		.text "KIL",128+"L"	;$f6
		.text "INI",128+"T"	;$f7
		.text "CHANG",128+"E"	;$f8
		.text "DAT",128+"E"	;$f9
		.text "MA",128+"N"	;$fa
		.byte 0
		.pend
;---------------------------
;Tokenizer modification (cfg_8)
;Allways tokenizes from buffer $200
;
;@ <- * *(toketized?) " RVSON? / /(tokenized?) % ^ ^(tokenized?) ' Font
;
tokencmd	.proc
		.text "@/%",94,95,39,92,"*";* and font not implemented
		.pend			;but needed for JiffyDos...

LW_mytoken	.proc
		inx
		bne notdirectmode	;in program line mode...
		ldy #8
lp		cmp tokencmd-1,y
		bne notwedge
		lda JiffyDos_present_exp
		beq n
		lda ActualDev
		sta $be			;Jiffydos...
n
		#psr $a5e3		;REM
		ldx $7a
		ldy #4
		tya
		jmp exit2basic

notwedge	dey
		bne lp

notdirectmode	sta cfg_8
		jsr $a57c
		ldx #0
		stx $7a
		ldy #4
		sty $0f
nxtch		lda $0200,x
		bmi copy
lt128		cmp #" "
		beq copy
		sta $08
		cmp #$22
		beq quote
		bit $0f
		bvs copy
		cmp #"A"
		bcc copy
		cmp #"Z"+1
		bcs copy
		sty $71
		ldy #$70
		sty $0b
		ldy #$ff
		stx $7a
		dex
srchl		iny
		inx
testnxt		lda $0200,x
		sec
		sbc newcommands,y
		beq srchl
		cmp #$80
		bne notfnd
		ora $0b
aga		ldy $71
copy		inx
		iny
		sta $01fb,y
		cmp #$00
		beq eobuf
		sbc #$3a
		beq dt
		cmp #$49
		bne notdata
dt		sta $0f
notdata		sec
		sbc #$55
		bne nxtch
		sta $08
toend		lda $0200,x
		beq copy
		cmp $08
		beq copy
quote		iny
		sta $01fb,y
		inx
		bne toend
notfnd		ldx $7a
		inc $0b
fnexn		iny
		lda newcommands-1,y
		bpl fnexn
		lda newcommands,y
		bne testnxt
		lda $0200,x
		bpl aga
eobuf		sta $01fd,y
		lda #$ff
		sta $7a
		jmp exit2basic
		.pend
;---------------------------------------
;Token executor modification (cfg_16)
;---------------------------------------
myverify	.proc
		lda #$01
		.byte SKIP2
myload		.proc
		lda #$00
		sta $0a
		sta ActualSecAddr
		lda #1
		sta ActualFNLength
		lda #$b3
		sta ActualFilename
		lda #$e1
		sta ActualFilename+1	;"*" as default filename (from kernal rom)
		#psr $e16f
mylosaback	.global
		#psr $e1e0
		jmp exit2basic
		.pend

mysave		.proc
		#psr $e159
		lda #$00
		sta ActualSecAddr
		sta ActualFNLength
		geq mylosaback
		.pend

myif		.proc
		jsr cad9e		;cfg_16
		jsr newchrgot		;otherwise there will be some problems in $8000-
		cmp #$89		;goto?
		beq ifgoto		;C=1
		cmp #$a7		;then?
		bne syntaxe
		jsr newchrget		;C=0 if number
ifgoto		ldx $61
		bne ifthen
		#psr $a93b		;rem rest of line
		jmp exit2basic

cad9e		#psr switch_16k
		#psr $ad9e
		jmp exit2basic

ifthen		cmp #$3a		;chrgot
		bcs mydoit
		eor #$30
		cmp #$10
		eor #$30
		bcs mydoit

		.if SUPERCPU=0
		tax
		.fi
		#psr $a8a0		;goto xxx
		.if SUPERCPU=0
		txa
		.fi
		jmp exit2basic
		.pend
;----
mydoit		.proc
		beq emptycommand
		asl
		bcc nottoken
		cmp #$23+$23
		bcs overt
		tay
hackedb2	.global
		lda basic_keyw+1,y
		bpl hackedb
		pha
		lda basic_keyw,y
		pha
		jmp basexeccmd

hackedb		ora #$80
		pha
		lda basic_keyw,y
		gcc tulin

mymisc		.global
		tax
		#sta_cfg_open
		lda setup_atribut_exp
		#sta_cfg_16
		and #CMOS_DOS_WEDGE
		beq syntaxe2
		txa
		ldy #$e9
keudhj		cmp tokencmd-$e9,y
		beq jmpu
		iny
		cpy #$f0
		bne keudhj
syntaxe2	#psr $a9a8
		.byte SKIP1
syntaxe		.global
		tax
		#psr $af08
		txa
emptycommand	jmp exit2basic

jmpu		tya
		asl
		gcs jht

overt		.global
		cmp #$4b+$4b		;GO?
		bne notgo
		#psr $a812
		jmp exit2basic

notgo		cmp #$e0		;>$f0
		bcc syntaxe
jht		tay
		#psr exit2basic
		lda insad-$df,y
		pha
		lda insad-$e0,y
tulin		pha
		jmp newchrget		;start in cfg_16

nottoken	lsr
		ldx #$00
		stx $0c
		sta $45
		cmp #"A"
		bcc mymisc
		cmp #1+"Z"
		bcs mymisc
		jmp basnottoken

basic_keyw	.word $A830,$A741,$AD1D,$A8F7;$80
		.word $ABA4,$ABBE,$B080,$AC05;$84
		.word $A9A4,$A89F,$A870,myif-$8001;$88
		.word $A81C,$A882,$A8D1,$A93A;$8c
		.word $A82E,$A94A,$B82C,myload-$8001;$90
		.word mysave-$8001,myverify-$8001,$B3B2,$B823;$94
		.word $AA7F,$AA9F,$A856,$A69B;$98
		.word $A65D,$AA85,$E129,$E1BD;$9c
		.word $E1C6,$AB7A,$A641

					;           ,<$BC39 ;$a0
					;          .byte <$BCCC,<$BC58,<$0310,<$B37D ;$a4
					;         .byte <$B39E,<$BF71,<$E097,<$B9EA ;$a8
					;        .byte <$BFED,<$E264,<$E26B,<$E2B4 ;$ac
					;       .byte <$E30E,<$B80D,<$B77C,<$B465 ;$b0
					;      .byte <$B7AD,<$B78B,<$B6EC,<$B700 ;$b4
					;     .byte <$B72C,<$B737

		.word baserrorchannel-1	;11
		.word basloadfile0-1	;12
		.word basloadfile1-1	;13
		.word basloadfile2-1	;14
		.word bassavefile0-1	;15
		.word basverifyfile0-1	;16
		.word basloadfile3-1	;17
insad		.word basdir-1		;0
		.word basdir1-1		;1
		.word bascd-1		;2
		.word basdelete-1	;3
		.word basmkdir-1	;4
		.word bashdinit-1	;5
		.word baskill-1		;6
		.word basinit-1		;7
		.word baschange-1	;8
		.word basdate-1		;9
		.word manager-1		;10
		.pend
;--------------------------------------
basdir					;not yet implemented
basdir1
bascd
basdelete
basmkdir
baschange
		inc $d020
		rts
;---------------------------------------
;Basic HDINIT
;---------------------------------------
bashdinit	.proc
		sta cfg_open
		jsr OP_save_zeropage
		jsr kill_drives

		lda #0
		jsr OP_hdinit
		bcs next
		bit msgmode
		bpl next
		jsr LWNO_print_imediate	;cfg_16
		.text "MASTER:",13,0
		jsr LWOP_print_drive_name;cfg_open
next		lda #1
		jsr OP_hdinit
		bcs next2
		bit msgmode
		bpl next2
		jsr LWNO_print_imediate	;cfg_16
		.text "SLAVE:",13,0
		jsr LWOP_print_drive_name;cfg_open
next2		lda #0
		jsr OP_XIT_hdinit_2
		lda #1
		jsr OP_XIT_hdinit_2
		jsr OP_hdinit_drivenumbers
		jmp OP_restore_zeropage

		.pend
;---------------------------------------
;Basic INIT (fills memory with 0 & softreset)
;---------------------------------------
basinit		.proc
		sei
		lda #$7f
		sta $dd0d
		lda $d011
		bpl *-3
		and #%11101111
		sta $d011
		ldx #del_ka-filler
loop		lda filler-1,x
		sta $01,x
		dex
		bne loop
		txa
		ldy #$2f
		sty $00
		ldy #$33
		jmp $02			;START !!!
;--------------------------------------
filler		.logical $0002
		sty $01
lp		sta $0600,x
		sta $8300,x
		inx
		bne lp
		inc lp+2
		inc lp+5
		bne lp
		sta $00
		jmp cart_reset		;!!!!!!
		.here
del_ka		.pend
;---------------------------------------
;Basic KILL (switches off cartridge)
;---------------------------------------
baskill		.proc
		sei
		jsr LWNO_set_old314vect
		jsr LWNO_basic_exit
		#sta_cfg_open
		ldx #del_ka2-exiter
loop		lda exiter-1,x
		sta $1ff,x
		dex
		bne loop
;		txa
;		jsr offdrive
;		lda #1
;		jsr offdrive
notpresent2	jsr LWNO_print_imediate	;cfg_16
		.text "BYE!",13,0
		lda #1
		jmp $200		;START !!!
;--------------------------------------
exiter		sta cfg_stnd
		sta kill_port
		jmp ($a002)
del_ka2		.pend
;---------------------------------------
;Basic DATE (prints date and time)
;---------------------------------------
basdate		.proc
		sta cfg_open
		jsr LWOP_read_clock

		#ldy_l_a day_exp
		ldx #$20
		jsr prtdaymth
		lda month_exp
		jsr bcd2bin
		clc
		adc #7
		tay
		ldx #$20
		jsr prtdaymth
		lda date_exp
		jsr prtbcdnum2
		lda hour_exp
		ldx #":"
		jsr prtbcdnum2
		lda min_exp
		jsr prtbcdnum
		lda sec_exp
		ldx #$20
		jsr prtbcdnum
		lda year_exp
		pha
		cmp #$80
		ldx #19			;19xx
		bcs *+4
		ldx #20			;20xx
		lda #0
		jsr printaxnum
		pla
		ldx #13
		gne prtbcdnum
		.pend

prtdaymth	lda dayc1-1,y
		jsr newchrout_t
		lda dayc2-1,y
		ora #64
		jsr newchrout_t
		lda dayc3-1,y
		ora #64
hth		jsr newchrout_t
		txa
		jsr newchrout_t
		sta cfg_open
		rts
;---------------------------------------
;Name of days and months
;
dayc1		.proc
		.text "SMTWTFSJFMAMJJASOND"
		.pend

dayc2		.proc
		.byte $15,$0f,$15,$05
		.byte $08,$12,$01
		.byte $01,$05,$01,$10,$01,$15
		.byte $15,$15,$05,$03,$0f,$05
		.pend

dayc3		.proc
		.byte $0e,$0e,$05,$04
		.byte $15,$09,$14
		.byte $0e,$02,$12,$12,$19,$0e
		.byte $0c,$07,$10,$14,$16,$03
		.pend

prtbcdnum2	pha
		and #$f0
		bne xkq
		lda #$20
		gne xkq2

prtbcdnum	pha
xkq		lsr
		lsr
		lsr
		lsr
		eor #$30
xkq2		jsr newchrout_t
		pla
		and #15
		ora #$30
		gne hth
;---------------------------------------
;Basic @ (Read error channel)
;---------------------------------------
baserrorchannel	.proc
		sta cfg_8
		cmp #"#"
		bne noch
		jsr $b79b		;This will fail if used in program above $8000
		stx ActualDev
		rts

noch		cmp #"$"
		bne noch2
		lda #0
		jsr tryopenfile
		bcs fileerror
		jsr xchrin
		jsr xchrin		;Skip load address

lp		jsr xchrin		;Skip linking
		jsr xchrin

		jsr xchrin
		tax
		jsr xchrin

		jsr printaxnum		;Print size

		lda #32
euo		jsr newchrout_t		;Print name
		jsr xchrin
		ora #0
		bne euo
		lda #13
		jsr newchrout_t
		jsr check_stop		;Stop?
		bne lp
		geq fileerror

tryopenfile	sta ActualSecAddr
		jsr calcfnlength
		jsr eatg
		jsr OP_findunusedchannel
		jsr newopen_t
		bcs oekj
		ldx ActualLogical
		jmp newchkin_t

xchrin		jsr newchrin_t
		ldy Status
		beq oekj
		pla
		pla
		#jmps fileerror
oekj		rts

noch2		lda #15			;Exec command
		jsr tryopenfile
		bcs fileerror
lp2		jsr newchrin_t		;Print error channel
		ldx Status
		jsr newchrout_t
		txa
		beq lp2

fileerror	lda ActualLogical	;Close file
		jsr newclose_t
		jmp newclrchn_t
		.pend

OP_findunusedchannel .proc
		sta cfg_open
		lda #0
		jsr search_logical_A	;Out of files?
		bne ok
		lda #128
lp		sec
		sbc #1
		beq ok			;should not happen ;)
		jsr search_logical_A
		beq lp
		sta ActualLogical
ok		rts
		.pend
;---------------------------
;Calculate filename length and position for BASIC wedge commands
;
calcfnlength	.proc
		ldx $7a
		clv
		gvc nnn

calcfnlengthlp	bvs dxb
		#sev set_vv
nnn		stx ActualFilename
		lda $7b
		sta ActualFilename+1
		ldy #0
		sty Status
hjk		lda (ActualFilename),y
		beq dxb
		inx
		cmp #$22
		beq calcfnlengthlp
		iny
		bne hjk
dxb		sty ActualFNLength
set_vv		rts
		.pend
;---------------------------
;Kill rest of basic line
;
eatglp		jsr newchrget		;otherwise there will be some problems in $8000-
eatg		sta cfg_16
		jsr newchrgot		;otherwise there will be some problems in $8000-
		cmp #0
		bne eatglp
		rts
;---------------------------
;Print decimal number in A/X
;
printaxnum	.proc
		tay
		sta cfg_open

		lda buffer_output_exp
		eor #STDOUT
		bne nonstandard
		lda buffer_input_exp
		cmp #STDIN
		bne nonstandard
		#psr gotobank3back
		gcs standard

nonstandard	#psr switch_16k
standard	#psr $bdcd
		tya
		jmp exit2basic
		.pend
;---------------------------------------
;Basic / % ^ (load file)
;---------------------------------------
basloadfile3	.proc
		lda #$80
		#sta_cfg_open
		sta load_autostart_exp
		#sta_cfg_16
		gne basloadfile1
		.pend

basloadfile2	.proc
		lda #1
		#sta_cfg_open
		sta load_autostart_exp
		#sta_cfg_16
		gne basloadfile0
		.pend

basverifyfile0	lda #1
		tax
		gne basloadin
basloadfile1	ldx #1
		.byte SKIP2
basloadfile0	ldx #0
		lda #0
basloadin	stx ActualSecAddr
		pha
		jsr calcfnlength
		jsr eatg
		#plx_a
		#psr $e171
		txa
		sta $0a
		jmp exit2basic

bassavefile0	.proc
		lda #0
		sta ActualSecAddr
		jsr calcfnlength
		jsr eatg
		#psr $e159
		jmp exit2basic
		.pend
;---------------------------------------
;Print drive name
;---------------------------------------
LWOP_print_drive_name .proc
		ldx #216
lp		sta cfg_open
		lda ident_model_number_exp-216,x
		bmi inval
		cmp #32			;skip control chars
		bcs *+4
inval		lda #32
		cmp #97
		bcc *+4
		sbc #32
		jsr newchrout_t		; chrout (cfg_16)
		inx
		bne lp
		#sta_cfg_open
		rts
		.pend
