;
; math.asm - mathematical functions
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;----------------------
;24 bit multiplication
;szam=szam*X, X=0 means 256
;higest 8 bits of 32bit result in A
;----------------------
mul_60		.proc
		ldx #60
mul		.proc
		dex
		stx szamtmp
in		ldy #8
		lda #0
		lsr szam
mul_lp1		bcc mul_vb1
		adc szamtmp
mul_vb1		ror a
		ror szam
		dey
		bne mul_lp1

		ldy #8
		lsr szam+1
mul_lp2		bcc mul_vb2
		adc szamtmp
mul_vb2		ror a
		ror szam+1
		dey
		bne mul_lp2

		ldy #8
		lsr szam+2
mul_lp3		bcc mul_vb3
		adc szamtmp
mul_vb3		ror a
		ror szam+2
		dey
		bne mul_lp3
		rts
		.pend
;----------------------
;28 bit multiplication
;szam=szam*X, X=0 means 256
;higest 8 bits of 32bit result in A
;----------------------
mul_p4bit	.proc
		ldy #4
		lsr szam+3
mul_lp3		bcc mul_vb3
		adc szamtmp
mul_vb3		ror a
		ror szam+3
		dey
		bne mul_lp3
		rts
		.pend
;----------------------
;32 bit addition
;szam=szam+A
;----------------------
sum		.proc
		clc
		adc szam
		sta szam
		bcc sum_x
		inc szam+1
		bne sum_x
		inc szam+2
		bne sum_x
		inc szam+3
sum_x		rts
		.pend
;----------------------
;32 bit division
;szam=szam/X
;A= remainder
;Warning: Do not divide by 0!
;----------------------
div		.proc
		stx szam+4
		ldx #32
		lda #0
lp		asl szam
		rol szam+1
		rol szam+2
		rol szam+3
		rol
		cmp szam+4
		bcc i
		sbc szam+4
		inc szam
i		dex
		bne lp
		rts
		.pend
