;
; selftest.asm - Selftesting
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

self_zeropage	= 2
self_memtest	= 6

selftest	.proc
		sta cfg_8
		lda #11
		sta $d011
		lda #self_zeropage
		sta $d020

		lda #255
lp2		ldy #2
		pha
		tax
		bpl nni4
		inx
		geq vvu

nni4		lda testpattern,x
		bne *+4
		ldx #255
		inx
		eor $0000,y
		beq vvu
		pla
		pha
		bmi vvu
		jmp *

vvu		lda testpattern,x
		sta $0000,y
		iny
		bne nni4
		pla
		clc
		adc #1
		cmp #19
		bne lp2

		lda #self_memtest
		sta $d020
		sta $d021

		ldx #0
dp		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $db00,x
		inx
		bne dp

		ldx #6
dp2		lda ramtxt,x
		sta $28,x
		lda #1
		sta $d828,x
		dex
		bpl dp2

		ldx #(mtestend-mtest)-1
dp3		lda mtest,x
		sta $2f,x
		dex
		bpl dp3

		lda #200
		sta $d016
		ldx #0
		stx $dd02
		stx $d015
		stx $d418
		lda #$fc
		sta $d030		;C128
		.if (SECOND_SID >> 8)=$d6
		lda $d030		;C128?
		lsr
		bcc *+5
		.fi
		stx SECOND_SID+$18	;Second SID
		lda #6
		sta $d018
		lda #27
		sta $d011
		sei
		lda #$37
		sta $01
		lda #$2f
		sta $00
		jmp $2f

mtestback	bcs memok

		lda #"!"
		sta $2d
		inc $d82d
		jmp *-3
memok
		lda #32
		ldx #0
ip		sta $400,x
		sta $500,x
		sta $600,x
		sta $700,x
		inx
		bne ip

		ldx #6
li		lda $28,x
		sta $428,x
		dex
		bpl li

		lda #22
		sta $d018

		ldx #0
		lda #1
ip2		sta $d800,x
		sta $d900,x
		sta $da00,x
		sta $db00,x
		inx
		bne ip2

		lda $d020
		sta $d021

		lda #122
		sta $42d

		ldx #7
li1a		lda de60txt,x
		sta $450,x
		dex
		bpl li1a

		ldx #$60
dtp		lda $9e00,x
		cmp $de00,x
		beq ti

		lda #"!"
		sta $456
		inc $d856
		jmp *-3

ti		inx
		bne dtp

		lda #122
		sta $456

		ldx #9
li2		lda romtxt,x
		sta $478,x
		dex
		bpl li2

		lda #$e0
		sta $3
		lda #0
		sta $2
		tay
		tax

		clc
cp		adc ($02),y
		bcc k
		clc
		inx
k		iny
		bne cp
		inc $03
		bne cp

		cmp #<50955		;R00
		bne *+6
		cpx #>50955
		beq kok

		cmp #<50954		;R03
		bne *+6
		cpx #>50954
		beq kok

		cmp #<50633		;R03swe
		bne *+6
		cpx #>50633
		beq kok

		cmp #<50955		;R43
		bne *+6
		cpx #>50955
		beq kok

		cmp #<49680		;R64
		bne *+6
		cpx #>49680
		beq kok

		cmp #<43493		;Jiffy 6.01
		bne *+6
		cpx #>43493
		beq kok

		cmp #<43147		;SCPU 2.04
		bne *+6
		cpx #>43147
		beq kok

		ldy #"?"
		.byte $2c
kok		ldy #122
		sty $480

		ldx #8
li3		lda rom2txt,x
		sta $4a0,x
		dex
		bpl li3

		lda #$a0
		sta $3

		lda #0
		tay
		tax

		clc
cp2		adc ($02),y
		bcc k2
		clc
		inx
k2		iny
		bne cp2
		inc $03
		bit $03
		bvc cp2

		cmp #<15702
		bne *+6
		cpx #>15702
		beq kok2

		ldy #"?"
		.byte $2c
kok2		ldy #122
		sty $4a7

		bit $d0bc
		bpl scpuskip

		ldx #9
li4		lda extramtxt,x
		sta $4c8,x
		dex
		bpl li4

		sta cfg_open
		ldy #0
llp		lda #$10
		sta $03

		ldx $4d0
		bpl nni
		inx
		geq vv2

nl2		ldx #0
		geq u

nni		lda testpattern,x
		beq nl2
		inx
u		eor ($02),y
		bne merror2
vv2		lda testpattern,x
		sta ($02),y
		iny
		bne nni
		inc $03
		bpl nni

		inc $4d0
		lda $4d0
		cmp #19
		bcc llp
		gcs oo

merror2		lda $4d0
		bmi vv2

		lda #"!"
		sta $4d0
		inc $d8d0
		jmp *-3

oo		lda #122
		sta $4d0

scpuskip	sta cfg_16

		ldx #9
li5		lda extromtxt,x
		sta $4f0,x
		dex
		bpl li5

		ldx #(rtestend-rtest)-1
dg		lda rtest,x
		sta $04,x
		dex
		bpl dg

		lda #0
		tax
		jsr $04

		sec
		sbc chksum
		bcs *+3
		dex
		sec
		sbc chksum+1
		bcs *+3
		dex

		cmp chksum
		bne kc
		cpx chksum+1
		beq kc2

kc		ldy #"!"
		sty $4f8
		inc $d8f8
		jmp *-3

kc2		lda #122
		sta $4f8

		.comment
		ldx #9
li6		lda latchtxt,x
		sta $518,x
		dex
		bpl li6

		ldy #0
		sty $2

dpf		ldx $2
		lda testpattern,x
		sta low_reg
		bne *+4
		ldx #255
		inx
		lda testpattern,x
		sta hig_reg

		ldx $2
		lda testpattern,x
		cmp low_reg
		beq *+3
		iny
		ora #0
		bne *+4
		ldx #255
		inx
		lda testpattern,x
		cmp hig_reg
		beq *+3
		iny
		inc $2
		lda $2
		cmp #19
		bne dpf

		cpy #0
		beq lok

		lda #"!"
		sta $520
		inc $d920
		jmp *-3

lok		lda #122
		sta $520
		.endc

		ldx #$00		;reset
		stx kill_port

		ldx #8
li7		lda nvramtxt,x
		sta $518,x
		dex
		bpl li7

		lda #0
		sta $3

lp3		lda #31
		sta $2
		lda #%11111110		;data write brust
		jsr cmos_start
		ldx $3
lp2j		lda testpattern,x
		bne *+4
		ldx #255
		inx
		jsr cmos_send_byte
		dec $2
		bne lp2j
		ldx #$00		;reset
		stx kill_port

		lda #31
		sta $2
		lda #%11111111		;read ram burst command
		jsr cmos_start
		ldx $3
lp		jsr cmos_read_byte	;read byte from RAM
		cmp testpattern,x
		beq tk
		ldx #0
		stx kill_port
		geq er

tk		lda testpattern,x
		bne *+4
		ldx #255
		inx
		dec $2
		bne lp
		ldx #$00		;reset
		stx kill_port

		inc $3
		lda $3
		cmp #19
		bcc lp3

		lda #122
		.byte $2c
er		lda #"!"
		sta $51f

		jmp *
;------------------------
cmos_start	ldx #$02
		stx kill_port		;UNreset
cmos_send_byte	jsr *+3
		jsr *+3
		jsr *+3
		sta clock_port		; bit 0
		lsr a
		rts

cmos_read_byte	jsr *+3
		jsr *+3
		jsr *+3
		lda clock_port		; bit 1
		lsr a
		tya
		ror a
		tay
		rts
;------------------------

ramtxt		.text "RAM ","["-64,255,"]"-64
de60txt		.text "DE60 ","["-64,32,"]"-64
romtxt		.text "KERNAL ","["-64,32,"]"-64
rom2txt		.text "BASIC ","["-64,32,"]"-64
extramtxt	.text "EXTRAM ","["-64,255,"]"-64
extromtxt	.text "EXTROM ","["-64,32,"]"-64
latchtxt	.text "BUFFER ","["-64,32,"]"-64
nvramtxt	.text "NVRAM ","["-64,32,"]"-64

rtest		.logical $4
bnk		sta bank_port3
		ldy #$80
		sty icr+2
		ldy #0
		clc
icr		adc $8000,y
		bcc hb
		clc
		inx
hb		iny
		bne icr
		inc icr+2
		bit icr+2
		bvc icr
		dec bnk+1
		ldy bnk+1
		cpy #<(bank_port0-1)
		bne bnk
		rts
		.here
rtestend

mtest		.logical $2f

		inc $1
lpp		inc at+2
		inc at2+2
		ldx $2d
		bpl nni2
		inx
		geq vv

nl		ldx #0
		geq at

nni2		lda testpattern2,x
		beq nl
		inx
at		eor $0000,y
at3		.byte $a9,merror-vv
vv		lda testpattern2,x
at2		sta $0000,y
		iny
		bne nni2
		inc at+2
		inc at2+2
		bne nni2
		lda #$d0		;bne
		sta at3

		inc $2d
		lda $2d
		cmp #19
		bcc lpp
		.byte $a9
merror		clc
		dec $1
mb		jmp mtestback

testpattern2
		.here

testpattern	.byte %10000000		;1
		.byte %01000000		;2
		.byte %00100000		;3
		.byte %00010000		;4
		.byte %00001000		;5
		.byte %00000100		;6
		.byte %00000010		;7
		.byte %00000001		;8
		.byte %11111111		;9
		.byte %01111111		;10
		.byte %10111111		;11
		.byte %11011111		;12
		.byte %11101111		;13
		.byte %11110111		;14
		.byte %11111011		;15
		.byte %11111101		;16
		.byte %11111110		;17
		.byte %01010101		;18
		.byte %00000000		;19
		.pend
mtestend
